
`service` is a tool that deploys and manages dæmons and services.

## Dependencies

You’ll need `crystal` and `make` to build the application, and `shards` to fetch a few Crystal libraries.

Run `shards install` to fetch the Crystal libraries.

## Building

`service` uses a `build.zsh`-generated Makefile.
You can run `make help` to get a list of all available build targets (“make commands”).

```sh
make help
```

To build and install the software with default configuration, run the following:

```sh
make
make install
```

If you want to alter the installation prefix or destination, use the following syntax:

```sh
make PREFIX=/usr DESTDIR=/some/fake/root install
```

If `make` complains that the Makefile is missing, you’ll have to generate it with the following command:

```sh
build.zsh
```

## Usage

Read `service.1` and `service.7` for more informations about how `service` is meant to be used.

## Quickstart

```sh
service add postgresql
service add gitea domain=gitea.test

service start postgresql

service show gitea
service status -v
service status -v gitea
```


